
import pygame
from pygame.locals import *
import os, sys

def Main(name):
    pygame.init()
    screen = pygame.display.set_mode((320, 200))
    img = pygame.image.load(name)
    screen.fill((255, 255, 255))
    screen.blit(img, (0, 0))
    pygame.display.flip()

    palette = file("palette.dat").read(768)
    lookup = dict()
    for i in xrange(255, -1, -1):
        r = ord(palette[ (i * 3) + 0 ])
        g = ord(palette[ (i * 3) + 1 ])
        b = ord(palette[ (i * 3) + 2 ])
        lookup[ (r, g, b) ] = i

    (name, ext) = os.path.splitext(name)
    out = file(name + ".c", "wt")
    out.write("static unsigned char %s_img[] = \n\"" % name)
            
    for y in xrange(200):
        for x in xrange(320):
            (r, g, b, a) = screen.get_at((x, y))
            i = lookup[ (r, g, b) ]
            out.write("\\x%02x" % i)
            if ((x % 16) == 15):
                out.write("\"\n\"")
    out.write("\";\n\n")
    out.close()
    pygame.quit()

if __name__ == "__main__":
    Main(sys.argv[ 1 ])

